<?php
/**
 * PPC Specialist functions and definitions
 *
 * @subpackage PPC Specialist
 * @since 1.0
 */

// theme setup
function ppc_specialist_setup() {	
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "wp-block-styles" );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( 'title-tag' );
	add_theme_support('custom-background',array(
		'default-color' => 'ffffff',
	));
	add_image_size( 'ppc-specialist-featured-image', 2000, 1200, true );
	add_image_size( 'ppc-specialist-thumbnail-avatar', 100, 100, true );

	load_theme_textdomain( 'ppc-specialist', get_template_directory() . '/languages' );

	$GLOBALS['content_width'] = 525;
	register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'ppc-specialist' ),
	) );

	add_theme_support( 'html5', array(
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	// Add theme support for Custom Logo.
	add_theme_support( 'custom-logo', array(
		'width'       => 250,
		'height'      => 250,
		'flex-width'  => true,
		'flex-height' => true,
	) );

	// Add theme support for selective refresh for widgets.
	add_theme_support( 'customize-selective-refresh-widgets' );
	/*
	 * Enable support for Post Formats.
	 *
	 * See: https://codex.wordpress.org/Post_Formats
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio','quote',) );
	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, and column width.
 	 */
	add_editor_style( array( 'assets/css/editor-style.css' ) );

	if ( ! defined( 'PPC_SPECIALIST_SUPPORT' ) ) {
	define('PPC_SPECIALIST_SUPPORT',__('https://wordpress.org/support/theme/ppc-specialist','ppc-specialist'));
	}
	if ( ! defined( 'PPC_SPECIALIST_REVIEW' ) ) {
		define('PPC_SPECIALIST_REVIEW',__('https://wordpress.org/support/theme/ppc-specialist/reviews/#new-post','ppc-specialist'));
	}
	if ( ! defined( 'PPC_SPECIALIST_LIVE_DEMO' ) ) {
	define('PPC_SPECIALIST_LIVE_DEMO',__('https://trial.ovationthemes.com/ppc-specialist/','ppc-specialist'));
	}
	if ( ! defined( 'PPC_SPECIALIST_BUY_PRO' ) ) {
	define('PPC_SPECIALIST_BUY_PRO',__('https://www.ovationthemes.com/products/email-marketing-wordpress-theme','ppc-specialist'));
	}
	if ( ! defined( 'PPC_SPECIALIST_PRO_DOC' ) ) {
	define('PPC_SPECIALIST_PRO_DOC',__('https://trial.ovationthemes.com/docs/ot-ppc-specialist-pro-doc/','ppc-specialist'));
	}
	if ( ! defined( 'PPC_SPECIALIST_FREE_DOC' ) ) {
	define('PPC_SPECIALIST_FREE_DOC',__('https://trial.ovationthemes.com/docs/ot-ppc-specialist-free-doc/','ppc-specialist'));
	}
	if ( ! defined( 'PPC_SPECIALIST_THEME_NAME' ) ) {
	define('PPC_SPECIALIST_THEME_NAME',__('Premium PPC Specialist Theme','ppc-specialist'));
	}
	if ( ! defined( 'PPC_SPECIALIST_BUNDLE_LINK' ) ) {
	define('PPC_SPECIALIST_BUNDLE_LINK',__('https://www.ovationthemes.com/products/wordpress-bundle','ppc-specialist'));
	}
	require get_template_directory() . '/inc/dashboard/dashboard-settings.php';
	require get_template_directory() . '/inc/admin/theme-upsell.php';
}
add_action( 'after_setup_theme', 'ppc_specialist_setup' );

//woocommerce//
//shop page no of columns
function ppc_specialist_woocommerce_loop_columns() {
	
	$retrun = get_theme_mod( 'ppc_specialist_archieve_item_columns', 3 );
    
    return $retrun;
}
add_filter( 'loop_shop_columns', 'ppc_specialist_woocommerce_loop_columns' );
function ppc_specialist_woocommerce_products_per_page() {

		$retrun = get_theme_mod( 'ppc_specialist_archieve_shop_perpage', 6 );
    
    return $retrun;
}
add_filter( 'loop_shop_per_page', 'ppc_specialist_woocommerce_products_per_page' );
// related products
function ppc_specialist_related_products_args( $args ) {
    $defaults = array(
        'posts_per_page' => get_theme_mod( 'ppc_specialist_related_shop_perpage', 3 ),
        'columns'        => get_theme_mod( 'ppc_specialist_related_item_columns', 3),
    );

    $args = wp_parse_args( $defaults, $args );

    return $args;
}
add_filter( 'woocommerce_output_related_products_args', 'ppc_specialist_related_products_args' );

// breadcrumb seperator
function ppc_specialist_woocommerce_breadcrumb_separator($ppc_specialist_defaults) {
    $ppc_specialist_separator = get_theme_mod('woocommerce_breadcrumb_separator', ' / ');

    // Update the separator
    $ppc_specialist_defaults['delimiter'] = $ppc_specialist_separator;

    return $ppc_specialist_defaults;
}
add_filter('woocommerce_breadcrumb_defaults', 'ppc_specialist_woocommerce_breadcrumb_separator');

//add animation class
if ( class_exists( 'WooCommerce' ) ) { 
	add_filter('post_class', function($ppc_specialist_classes, $class, $product_id) {
	    if( is_shop() || is_product_category() ){
	        
	        $ppc_specialist_classes = array_merge(['wow','zoomIn'], $ppc_specialist_classes);
	    }
	    return $ppc_specialist_classes;
	},10,3);
}

//woocommerce-end//
// Admin scripts and styles
function ppc_specialist_enqueue_admin_script( $hook ) {
	wp_enqueue_style(
		'ppc-specialist-admin-style',
		get_template_directory_uri() . '/assets/css/admin-style.css'
	);
	wp_enqueue_script(
		'ppc-specialist-admin-js',
		get_theme_file_uri( '/assets/js/ppc-specialist-admin.js' ),
		array( 'jquery' ),
		'1.0.0',
		true
	);
	wp_localize_script(
		'ppc-specialist-admin-js',
		'ppc_specialist_localize',
		array(
			'ajax_url'      => admin_url( 'admin-ajax.php' ),
			'nonce'         => wp_create_nonce( 'ppc_specialist_dismissed_notice_nonce' ),
			'dismiss_nonce' => wp_create_nonce( 'ppc_specialist_dismissed_notice_nonce' ),
		)
	);
}
add_action( 'admin_enqueue_scripts', 'ppc_specialist_enqueue_admin_script' );

function ppc_specialist_excerpt_enabled(){
	if(get_theme_mod('ppc_specialist_blog_meta_content') == 'Excerpt Content' ) {
		return true;
	}
	return false;
}

/* Excerpt Limit Begin */
function ppc_specialist_string_limit_words($string, $word_limit) {
	$words = explode(' ', $string, ($word_limit + 1));
	if(count($words) > $word_limit)
	array_pop($words);
	return implode(' ', $words);
}

// tag count
function ppc_specialist_display_post_tag_count() {
    $ppc_specialist_tags = get_the_tags();
    $ppc_specialist_tag_count = ($ppc_specialist_tags) ? count($ppc_specialist_tags) : 0;
    $ppc_specialist_tag_text = ($ppc_specialist_tag_count === 1) ? 'tag' : 'tags';
    echo $ppc_specialist_tag_count . ' ' . $ppc_specialist_tag_text;
}

// Date formatting
function ppc_specialist_display_shop_date() {
    // Get the date type option
    $ppc_specialist_date_type = get_theme_mod( 'ppc_specialist_date_type', 'published' );

    // Determine the date to display based on the type
    if ( $ppc_specialist_date_type === 'modified' && get_the_modified_time( 'U' ) !== get_the_time( 'U' ) ) {
        $ppc_specialist_date_to_display = get_the_modified_date( get_option( 'date_format' ) );
    } else {
        $ppc_specialist_date_to_display = get_the_date( get_option( 'date_format' ) );
    }

    // Output the date HTML

    echo esc_html( $ppc_specialist_date_to_display );
}

//media post format
function ppc_specialist_get_media($ppc_specialist_type = array()){
	$ppc_specialist_content = apply_filters( 'the_content', get_the_content() );
  	$output = false;

  // Only get media from the content if a playlist isn't present.
  if ( false === strpos( $ppc_specialist_content, 'wp-playlist-script' ) ) {
    $output = get_media_embedded_in_content( $ppc_specialist_content, $ppc_specialist_type );
    return $output;
  }
}

// front page template
function ppc_specialist_front_page_template( $template ) {
	return is_home() ? '' : $template;
}
add_filter( 'frontpage_template',  'ppc_specialist_front_page_template' );

// excerpt function
function ppc_specialist_custom_excerpt() {
    $ppc_specialist_excerpt = get_the_excerpt();
    $ppc_specialist_plain_text_excerpt = wp_strip_all_tags($ppc_specialist_excerpt);
    
    // Get dynamic word limit from theme mod
    $ppc_specialist_word_limit = esc_attr(get_theme_mod('ppc_specialist_post_excerpt', '30'));
    
    // Limit the number of words
    $ppc_specialist_limited_excerpt = implode(' ', array_slice(explode(' ', $ppc_specialist_plain_text_excerpt), 0, $ppc_specialist_word_limit));

    echo esc_html($ppc_specialist_limited_excerpt);
}

// typography
function ppc_specialist_fonts_scripts() {
	$ppc_specialist_headings_font = esc_html(get_theme_mod('ppc_specialist_headings_text'));
	$ppc_specialist_body_font = esc_html(get_theme_mod('ppc_specialist_body_text'));

	if( $ppc_specialist_headings_font ) {
		wp_enqueue_style( 'ppc-specialist-headings-fonts', '//fonts.googleapis.com/css?family='. $ppc_specialist_headings_font );
	} else {
		wp_enqueue_style( 'ppc-specialist-source-sans', '//fonts.googleapis.com/css?family=Roboto:ital,wght@0,100;0,300;0,400;0,500;0,700;0,900;1,100;1,300;1,400;1,500;1,700;1,900');
	}
	if( $ppc_specialist_body_font ) {
		wp_enqueue_style( 'ppc-specialist-body-fonts', '//fonts.googleapis.com/css?family='. $ppc_specialist_body_font );
	} else {
		wp_enqueue_style( 'ppc-specialist-source-body', '//fonts.googleapis.com/css?family=Roboto:ital,wght@0,100;0,300;0,400;0,500;0,700;0,900;1,100;1,300;1,400;1,500;1,700;1,900');
	}
}
add_action( 'wp_enqueue_scripts', 'ppc_specialist_fonts_scripts' );

// Footer Text
function ppc_specialist_copyright_link() {
    $ppc_specialist_footer_text = get_theme_mod('ppc_specialist_footer_text', esc_html__('PPC Specialist WordPress Theme', 'ppc-specialist'));
    $ppc_specialist_credit_link = esc_url('https://www.ovationthemes.com/products/free-ppc-wordpress-theme');

    echo '<a href="' . $ppc_specialist_credit_link . '" target="_blank">' . esc_html($ppc_specialist_footer_text) . '<span class="footer-copyright">' . esc_html__(' By Ovation Themes', 'ppc-specialist') . '</span></a>';
}

// custom sanitizations
// dropdown
function ppc_specialist_sanitize_dropdown_pages( $page_id, $setting ) {
	$page_id = absint( $page_id );
	return ( 'publish' == get_post_status( $page_id ) ? $page_id : $setting->default );
}
// slider custom control
if ( ! function_exists( 'ppc_specialist_sanitize_integer' ) ) {
	function ppc_specialist_sanitize_integer( $input ) {
		return (int) $input;
	}
}
// range contol
function ppc_specialist_sanitize_number_absint( $number, $setting ) {

	// Ensure input is an absolute integer.
	$number = absint( $number );

	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;

	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );

	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );

	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );

	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}
// select post page
function ppc_specialist_sanitize_select( $input, $setting ){  
    $input = sanitize_key($input);    
    $choices = $setting->manager->get_control( $setting->id )->choices;
    return ( array_key_exists( $input, $choices ) ? $input : $setting->default );      
}
// toggle switch
function ppc_specialist_callback_sanitize_switch( $value ) {
	// Switch values must be equal to 1 of off. Off is indicator and should not be translated.
	return ( ( isset( $value ) && $value == 1 ) ? 1 : 'off' );
}
//choices control
function ppc_specialist_sanitize_choices( $input, $setting ) {
    global $wp_customize; 
    $control = $wp_customize->get_control( $setting->id ); 
    if ( array_key_exists( $input, $control->choices ) ) {
        return $input;
    } else {
        return $setting->default;
    }
}
// phone number
function ppc_specialist_sanitize_phone_number( $phone ) {
  return preg_replace( '/[^\d+]/', '', $phone );
}
// Sanitize Sortable control.
function ppc_specialist_sanitize_sortable( $val, $setting ) {
	if ( is_string( $val ) || is_numeric( $val ) ) {
		return array(
			esc_attr( $val ),
		);
	}
	$sanitized_value = array();
	foreach ( $val as $item ) {
		if ( isset( $setting->manager->get_control( $setting->id )->choices[ $item ] ) ) {
			$sanitized_value[] = esc_attr( $item );
		}
	}
	return $sanitized_value;
}

// widgets
function ppc_specialist_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Sidebar', 'ppc-specialist' ),
		'id'            => 'sidebar-1',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'ppc-specialist' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'ppc-specialist' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your pages and posts', 'ppc-specialist' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'ppc-specialist' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'ppc-specialist' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 1', 'ppc-specialist' ),
		'id'            => 'footer-1',
		'description'   => __( 'Add widgets here to appear in your footer.', 'ppc-specialist' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 2', 'ppc-specialist' ),
		'id'            => 'footer-2',
		'description'   => __( 'Add widgets here to appear in your footer.', 'ppc-specialist' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 3', 'ppc-specialist' ),
		'id'            => 'footer-3',
		'description'   => __( 'Add widgets here to appear in your footer.', 'ppc-specialist' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 4', 'ppc-specialist' ),
		'id'            => 'footer-4',
		'description'   => __( 'Add widgets here to appear in your footer.', 'ppc-specialist' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
}
add_action( 'widgets_init', 'ppc_specialist_widgets_init' );

//Enqueue scripts and styles.
function ppc_specialist_scripts() {

	require_once get_theme_file_path( 'inc/wptt-webfont-loader.php' );

	wp_enqueue_style(
		'roboto',
		wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,100;0,300;0,400;0,500;0,700;0,900;1,100;1,300;1,400;1,500;1,700;1,900&display=swap' ),
		array(),
		'1.0'
	);

	//Bootstarp 
	wp_enqueue_style( 'ppc-specialist-bootstrap-style', get_template_directory_uri().'/assets/css/bootstrap.css' );	
	
	// Theme stylesheet.
	wp_enqueue_style( 'ppc-specialist-style', get_stylesheet_uri() );

	// Rtl
	wp_style_add_data('ppc-specialist-style', 'rtl', 'replace');

	// Theme Customize CSS.
	require get_parent_theme_file_path( 'inc/extra_customization.php' );
	wp_add_inline_style( 'ppc-specialist-style',$ppc_specialist_custom_style );

	//font-awesome
	wp_enqueue_style( 'ppc-specialist-font-awesome-style', get_template_directory_uri().'/assets/css/fontawesome-all.css' );

	// Block Style
	wp_enqueue_style( 'ppc-specialist-block-style', esc_url( get_template_directory_uri() ).'/assets/css/blocks.css' );

	//Custom JS
	wp_enqueue_script( 'ppc-specialist-custom.js', get_theme_file_uri( '/assets/js/theme-script.js' ), array( 'jquery' ), true );

	//Nav Focus JS
	wp_enqueue_script( 'ppc-specialist-navigation-focus', get_theme_file_uri( '/assets/js/navigation-focus.js' ), array( 'jquery' ), true );


	//Bootstarp JS
	wp_enqueue_script( 'ppc-specialist-bootstrap-js', get_theme_file_uri( '/assets/js/bootstrap.js' ), array( 'jquery' ),true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	if (get_option('ppc_specialist_animation_enable', false) !== 'off') {
		//wow.js
		wp_enqueue_script( 'ppc-specialist-wow-js', get_theme_file_uri( '/assets/js/wow.js' ), array( 'jquery' ), true );

		//animate.css
		wp_enqueue_style( 'ppc-specialist-animate-css', get_template_directory_uri().'/assets/css/animate.css' );
	}
}
add_action( 'wp_enqueue_scripts', 'ppc_specialist_scripts' );

function ppc_specialist_block_editor_styles() {
	// Block styles.
	wp_enqueue_style( 'ppc-specialist-block-editor-style', trailingslashit( esc_url ( get_template_directory_uri() ) ) . '/assets/css/editor-blocks.css' );
}
add_action( 'enqueue_block_editor_assets', 'ppc_specialist_block_editor_styles' );

# Load scripts and styles.(fontawesome)
add_action( 'customize_controls_enqueue_scripts', 'ppc_specialist_customize_controls_register_scripts' );
function ppc_specialist_customize_controls_register_scripts() {
	
	wp_enqueue_style( 'ppc-specialist-ctypo-customize-controls-style', trailingslashit( esc_url(get_template_directory_uri()) ) . '/assets/css/customize-controls.css' );
}

require get_parent_theme_file_path( '/inc/custom-header.php' );
require get_parent_theme_file_path( '/inc/template-tags.php' );
require get_parent_theme_file_path( '/inc/template-functions.php' );
require get_parent_theme_file_path( '/inc/customizer.php' );
require get_parent_theme_file_path( '/inc/typofont.php' );
require get_parent_theme_file_path( '/inc/breadcrumb.php' );
require_once get_template_directory() . '/inc/admin/welcome-notice.php';
require get_parent_theme_file_path( 'inc/sortable/sortable_control.php' );

add_action( 'admin_bar_menu', 'ppc_specialist_add_upgrade_button', 100 );

function ppc_specialist_add_upgrade_button( $ppc_specialist_wp_admin_bar ) {

    $ppc_specialist_theme_name = wp_get_theme()->get( 'Name' );

    $ppc_specialist_args = array(
        'id'    => 'ppc_specialist_upgrade',
        'title' => '<span style="color:#fff;font-weight:600;">
            🚀 Upgrade to ' . esc_html( $ppc_specialist_theme_name ) . ' Pro - 20% OFF 
            <span style="background:#ff5722;color:#fff;padding:2px 8px;border-radius:3px;margin-left:6px;">
                Buy Now
            </span>
        </span>',
        'href'  => esc_url( PPC_SPECIALIST_BUY_PRO ),
        'meta'  => array(
            'class'  => 'ppc-specialist-upgrade-btn',
            'title'  => 'Upgrade to Pro',
            'target' => '_blank'
        )
    );

    $ppc_specialist_wp_admin_bar->add_node( $ppc_specialist_args );
}